// <ACEStransformID>urn:ampas:aces:transformId:v1.5:IDT.Panasonic.VLog_VGamut.a1.v1</ACEStransformID> 
// <ACESuserName>ACES 1.0 Input - Panasonic VLog VGamut</ACESuserName> 
//
// IDT for Panasonic Varicam 35
// by Panasonic

import "utilities";

const float cutInv = 0.181;
const float b = 0.00873;
const float c = 0.241514;
const float d = 0.598206;

const float mat[][] = { {0.724382758, 0.166748484, 0.108497411},
                        {0.021354009, 0.985138372, -0.006319092},
                        {-0.009234278, -0.00104295, 1.010272625} };

float vLogToLinScene(float x) {
	if (x <= cutInv)
		return (x - 0.125) / 5.6;
	else
		return pow(10, (x-d)/c) - b;
}

void
main
	(
	input varying float rIn,
	input varying float gIn,
	input varying float bIn,
	input varying float aIn,
	output varying float rOut,
	output varying float gOut,
	output varying float bOut,
	output varying float aOut)

{

   // Convert V-Log to linear scene reflectance:
   
   float rLin = vLogToLinScene(rIn);
   float gLin = vLogToLinScene(gIn);
   float bLin = vLogToLinScene(bIn);

   // Apply IDT matrix:

   rOut = mat[0][0] * rLin + mat[0][1] * gLin + mat[0][2] * bLin;
   gOut = mat[1][0] * rLin + mat[1][1] * gLin + mat[1][2] * bLin;
   bOut = mat[2][0] * rLin + mat[2][1] * gLin + mat[2][2] * bLin;
   
   aOut = aIn;
}